This file is part of the Basilic system
Copyright (C) 2004  Gilles Debunne (Gilles.Debunne@imag.fr)
Version 1.5.14, packaged on May 2, 2007.

http://artis.imag.fr/Software/Basilic

Basilic  is  free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published
by the Free Software Foundation; either version 2 of the License,
or (at your option) any later version.

Basilic  is  distributed  in the hope that it will be useful, but
WITHOUT  ANY  WARRANTY ; without  even  the  implied  warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with Basilic; if not, write to the Free Software Foundation
Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
<?php

# Header
echo "<?xml version='1.0' encoding='iso-8859-1'?>\n";
echo "<!DOCTYPE html PUBLIC '-//W3C//DTD XHTML 1.0 Strict//$lg'\n";
echo "    'http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd'>\n";
echo "<html xmlns='http://www.w3.org/1999/xhtml' xml:lang='en' lang='$lg'>\n";
echo "<head>\n";

# Title of the page
if (!isset($title)) $title="@@LabName@@";
echo " <title>$title</title>\n";

echo " <meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\" />\n";

# favicon
if (!isset($favicon)) $favicon="/@@ImagesPath@@/basilic.ico";
echo " <link rel='shortcut icon' href='$favicon' />\n";

# Local browser detection :
# Simply compares browser remote address with a fixed ip mask
# May be changed to implement a more complex behavior.
$local=(substr($_SERVER["REMOTE_ADDR"],0,strlen("@@RemoteAddr@@")) == "@@RemoteAddr@@");

# Header stylesheet
echo " <link rel='stylesheet' href='/@@CSSPath@@/header.css' type='text/css' />\n";

# User defined parameters
if (!empty($css))   		echo " <link rel='stylesheet' href='$css' type='text/css' />\n";
if (!empty($metaKeywords))  	echo " <meta name='keywords' content='$metaKeywords' />\n";
if (!empty($metaDescription))  	echo " <meta name='description' content='$metaDescription' />\n";
echo "</head>\n\n<body>\n";

# Banner
echo "<div id='banner'>\n";
echo "  <a href='/'>Home</a>\n";

if ($lg=="fr")
{
  echo "  <a href='/Recherche'>Recherche</a>\n";
  echo "  <a href='/Equipe'>&Eacute;quipe</a>\n";
}
else
{
  echo "  <a href='/Research'>Research</a>\n";
  echo "  <a href='/Members'>Members</a>\n";
}

echo "  <a href='/@@PublicationsPath@@'>Publications</a>\n";

if ($local)
  echo "  <a href='/@@BasilicIntranetPath@@'>Intranet</a>\n";

// Add previous parameters
$otherPage = str_replace("?", "&amp;", $_SERVER["REQUEST_URI"]);

if ($lg=="fr")
{
  echo "  <a href='/@@PublicationsPath@@/setLanguage.php?lg=en&amp;page=$otherPage'>\n";
  echo "   <img alt='English version' width='20' height='12' src='/@@ImagesPath@@/en.png' />\n  </a>\n";
}
else
{
  echo "  <a href='/@@PublicationsPath@@/setLanguage.php?lg=fr&amp;page=$otherPage'>\n";
  echo "   <img alt='Version fran&ccedil;aise' width='20' height='12' src='/@@ImagesPath@@/fr.png' />\n  </a>\n";
}

echo "</div>\n";

echo "\n<div style='height:4px;'>&nbsp;</div>\n\n";

echo "<div id='content'>\n";
?>
