This file is part of the Basilic system
Copyright (C) 2004  Gilles Debunne (Gilles.Debunne@imag.fr)
Version 1.5.14, packaged on May 2, 2007.

http://artis.imag.fr/Software/Basilic

Basilic  is  free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published
by the Free Software Foundation; either version 2 of the License,
or (at your option) any later version.

Basilic  is  distributed  in the hope that it will be useful, but
WITHOUT  ANY  WARRANTY ; without  even  the  implied  warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with Basilic; if not, write to the Free Software Foundation
Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
<?php

function context()
{
  $text="\n\nContext :\n";
  $text.="On ".date("l j F Y G:i:s")."\n";
  $text.="SCRIPT_URL:      ".$_SERVER["SCRIPT_URL"]."\n";
  $text.="QUERY_STRING:    ".$_SERVER["QUERY_STRING"]."\n";
  $text.="SCRIPT_FILENAME: ".$_SERVER["SCRIPT_FILENAME"]."\n";
  $text.="REMOTE_ADDR :    ".$_SERVER["REMOTE_ADDR"]."\n";
  $text.="HTTP_REFERER :   ".$_SERVER["HTTP_REFERER"]."\n";
  $text.="\n------------------------------------------\n\n";
  return $text;
}

function sendMessage($message)
{
  $adminNot="@@AdminNotification@@";
  if (strstr($adminNot, '@'))
    error_log($message.context(), 1, $adminNot, "Subject:Publication server error\n");
  else
    error_log($message.context(), 3, $adminNot);
}

function error($message)
{
  echo "<p>\n<span style='color:red;'><b>Error</b></span> : $message\n</p>\n";
  sendMessage($message);
  die();
}

function connectToSql($name, $password)
{
  $database="@@mysqlDatabase@@";
  $host="@@mysqlHost@@";

  if (!$link = mysql_connect($host, $name, $password))
    {
      sendMessage("Unable to connect to mySQL server\nHost=$host\nName=$name");
      die("Unable to connect to mySQL server. Administrator has been warned.");
    }

  if (!mysql_select_db($database, $link))
    {
      sendMessage("Unable to select $database mySQL database");
      echo("Unable to select mySQL database. Administrator has been warned.");
      die("</body>\n</html>\n");
    }
}

function sqlConnect()
{
  connectToSql("@@mysqlPublicUser@@", "@@mysqlPublicPassword@@");
}

function intranetSqlConnect()
{
  connectToSql("@@mysqlIntranetUser@@", "@@mysqlIntranetPassword@@");
}

function sqlQuery($query)
{
  if ($result = mysql_query($query))
    return $result;
  else
    {
      sendMessage("Invalid sql query : $query");
      echo("Invalid Sql query. Administrator has been warned\n");
      // echo("Debug : Invalid Sql query : <br />\n<code>$query</code>\n");
      die("</body>\n</html>\n");
    }
}

?>
