This file is part of the Basilic system
Copyright (C) 2004  Gilles Debunne (Gilles.Debunne@imag.fr)
Version 1.5.14, packaged on May 2, 2007.

http://artis.imag.fr/Software/Basilic

Basilic  is  free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published
by the Free Software Foundation; either version 2 of the License,
or (at your option) any later version.

Basilic  is  distributed  in the hope that it will be useful, but
WITHOUT  ANY  WARRANTY ; without  even  the  implied  warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with Basilic; if not, write to the Free Software Foundation
Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
<html>
<head>
 <meta http-equiv='pragma' content='no-cache'>
 <meta http-equiv='expires' content='0'>
 <link rel="stylesheet" href="/@@CSSPath@@/backoffice.css" type="text/css" />
</head>

<body>

<h1>Author edition</h1>

<div class='inputForm'>
<form action='authorAction.php' name='authorForm'>
 <input type='hidden' name='action' value='NONE' />

<?php 
// If an $id parameter is provided, display and edit the corresponding author.
// Otherwise, edit a new author

// Get record id if it exists
if (isset($_GET) && isset($_GET["id"]))
  $id = $_GET["id"];

require("../utils.php");
sqlConnect();

if (!empty($id))
{
  $result = sqlQuery("SELECT * FROM authors WHERE id=$id");
  if (mysql_num_rows($result)==0)
    die("Error - No author found with id $id - Aborting\n");
  $row=mysql_fetch_array($result);
}
else
{
  $fields=array("first","last","url");
  foreach ($fields as $field)
    $row["$field"]="";
}

$t_obl = array("last","first");
$t_opt = array("url");
$t_opt = array_merge($t_obl, $t_opt);
?>

<script language="javascript">
// Check that all required field are filled
function chk()
{
  d=document.authorForm;
  <?php
  for ($i=0; $i<count($t_obl); $i++)
    echo " if (d.$t_obl[$i].value==''){\n  window.alert('Warning!\\nYou must fill the field \"$t_obl[$i]\".');\n  d.$t_obl[$i].focus();\n  return false;\n }\n";
  ?>
  return true;
}
function add()
{
  a=chk();
  if (a)
    {
      document.authorForm.action.value="add";
      document.authorForm.submit();
    }
}
function update()
{
  a=chk();
  if (a)
    {
      document.authorForm.action.value="update";
      document.authorForm.submit();
    }
}
function del()
{
  a=window.confirm("Warning!\nAre you sure you want to DEFINITIVELY delete this record ?");
  if (a)
    {
      document.authorForm.action.value="delete";
      document.authorForm.submit();
    }
}
</script>

<?php
$lineNb=0;

function line($str, $width)
{
  global $lineNb;
  global $t_obl;
  global $row;
  
  echo " <div class='".(($lineNb==0)?"even":"odd")."'>\n";
  $lineNb = 1-$lineNb;

  // Optionnal or compulsory field
  if (in_array($str,$t_obl))
    {
      $optClass = "required";
      $imgSrc = "/@@ImagesPath@@/required.png";
    }
  else
    {
      $optClass = "";
      $imgSrc = "/@@ImagesPath@@/empty.png";
    }
  
  echo "  <span class='label $optClass'>$str &nbsp;\n";
  echo "   <img src='$imgSrc' width='6' height='12' alt=''/> &nbsp; </span>\n";
  echo "  <input name='$str' size='".min(50, $width)."' maxlength='$width' value='$row[$str]' />\n";
  echo " </div>\n";
}

echo " <input type='hidden' name='id' value='$id' />\n";

line("first", 30);
line("last", 30);
line("url", 100);

echo " <div class='buttons'>\n";
if (!empty($id))
{
  echo "  <input type='button' value=' Update ' onClick='javascript:update();'> &nbsp;\n";
  echo "  <input style='color:red;' type='button' value=' Delete ' onClick='javascript:del();'>\n";
  echo "  <input type='button' value=' Cancel ' onClick='window.location.href=\"index.html\"';'> &nbsp;\n";
}
else
  echo "  <input type='button' value=' Add author ' onClick='javascript:add();'>\n";
echo " </div>\n";

echo "</form>\n";
echo " </div>\n\n";
echo "Fields in red must be filled\n\n";

if (!empty($id))
{
echo " <div class='information'>\n";
  echo "List of publications (id=$id) : <br />\n";

  $result = sqlQuery("SELECT id,bibTex,year,title from publis,publiauthors WHERE publiauthors.idAuthor=$id AND publiauthors.idPubli=publis.id ORDER BY year DESC");
  while ($result && $row=mysql_fetch_array($result))
    echo " <a href='/@@PublicationsPath@@/$row[year]/$row[bibTex]/' target='_top'>".$row["bibTex"]."</a> ".$row["title"]."<br />\n";
echo " </div>\n";
}

?>

</body>
</html>
