This file is part of the Basilic system
Copyright (C) 2004  Gilles Debunne (Gilles.Debunne@imag.fr)
Version 1.5.14, packaged on May 2, 2007.

http://artis.imag.fr/Software/Basilic

Basilic  is  free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published
by the Free Software Foundation; either version 2 of the License,
or (at your option) any later version.

Basilic  is  distributed  in the hope that it will be useful, but
WITHOUT  ANY  WARRANTY ; without  even  the  implied  warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with Basilic; if not, write to the Free Software Foundation
Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
<html>
<head>
  <meta http-equiv='pragma' content='no-cache'>
  <meta http-equiv='expires' content='0'>
  <link rel="stylesheet" href="/@@CSSPath@@/backoffice.css" type="text/css" />
</head>

<body>

<h1>Publications with missing documents</h1>

<div style='text-align:left;margin-left:10%'>

<?php

require("../utils.php");
require("../updatePubliDocs.php");
intranetSqlConnect();

if (isset($_GET))
{
  $year=$_GET["updateYear"];
  $author=$_GET["authorName"];
  $update=$_GET["update"];
}

$query="SELECT id,bibTex,year,title from publis";
if (!empty($year))
  $query.=" WHERE year=$year";

$query.=" ORDER BY year DESC";
$result = sqlQuery($query);

if (mysql_num_rows($result) == 0)
     echo "No publication found.";

// For each publication
while ($result && $row=mysql_fetch_array($result))
{
  $id=$row["id"];
  // echo "$row[id] $row[bibTex] $row[title] <br />\n";
		
  if (!empty($author))
    {
      $authorFound=0;
      $aresult = sqlQuery("SELECT DISTINCT id,first,last from authors,publiauthors WHERE publiauthors.idAuthor=authors.id AND publiauthors.idPubli=$id");
      while ($aresult && ($arow=mysql_fetch_array($aresult)) && (!$authorFound))
	$authorFound = ((strtolower($arow["first"]) == strtolower($author)) ||
			(strtolower($arow["last"]) == strtolower($author)));
      if (!$authorFound)
	continue;
    }
		
  // Update publication documents
  if (!empty($update))
    updatePubliDocs($id);

  // Parse associated documents
  $nbImages=0;
  $nbMovies=0;
  $nbAbstract=0;
  $nbPDFPS=0;
  $errorMessage="";
  
  $dresult = sqlQuery("SELECT type FROM docs,publidocs where docs.id=publidocs.idDoc AND publidocs.idPubli=$id");
  while ($dresult && $drow=mysql_fetch_array($dresult))
    {
      $type=$drow["type"];
      if ($type=="IMG") $nbImages++;
      else if ($type=="MOV") $nbMovies++;
      else if ($type=="ABS") $nbAbstract++;
      else if ($type=="PDF" || $type=="PS") $nbPDFPS++;
    }
  if ($nbPDFPS==0) $errorMessage.="No PDF or PS &nbsp; ";
  if ($nbImages==0) $errorMessage.="No image &nbsp; ";
  if ($nbAbstract==0) $errorMessage.="No abstract &nbsp; ";
  // if ($nbImages>12) $errorMessage.="Too many images ($nbImages&gt;12)! &nbsp; ";
  // if (($nbImages+$nbMovies)>18) $errorMessage.="Too many images/movies (".($nbImages+$nbMovies)."&gt;18)! &nbsp; ";

  if (!empty($errorMessage))
    {
      $href="/@@PublicationsPath@@/$row[year]/$row[bibTex]";
      echo "<a href='$href' target='_top'>$row[bibTex]</a> &nbsp; $errorMessage<br />\n";
    }
}
?>

<p>Done</p>

</div>
</body>
</html>
